package org.isaacparker.ftpstuffwedo;

import java.awt.MouseInfo;
import java.awt.Point;
import java.io.IOException;

import org.apache.commons.net.ftp.FTPFile;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DragDetectEvent;
import org.eclipse.swt.events.DragDetectListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseMoveListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.widgets.Tree;
import org.eclipse.swt.widgets.TreeColumn;
import org.eclipse.swt.widgets.TreeItem;
import org.eclipse.swt.widgets.Control;


public class LoginList {

	protected static Shell shell;
	private Text txtFtpurl;
	private Text txtFtpusername;
	private Text txtFtppassword;
	private Text txtFtpport;

	static Label lblStatus;

	/**
	 * Launch the application.
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			LoginList window = new LoginList();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Display display = Display.getDefault();
		createContents();
		shell.open();
		shell.layout();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
	}

	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		shell = new Shell();
		shell.setSize(500, 572);
		shell.setText("SWT Application");

		txtFtpurl = new Text(shell, SWT.BORDER);
		txtFtpurl.setBounds(75, 10, 126, 19);

		txtFtpusername = new Text(shell, SWT.BORDER);
		txtFtpusername.setBounds(75, 35, 163, 19);

		txtFtppassword = new Text(shell, SWT.BORDER);
		txtFtppassword.setBounds(75, 60, 163, 19);

		txtFtpport = new Text(shell, SWT.BORDER);
		txtFtpport.setBounds(207, 10, 31, 19);

		lblStatus = new Label(shell, SWT.NONE);
		lblStatus.setAlignment(SWT.RIGHT);
		lblStatus.setBounds(244, 531, 246, 14);
		lblStatus.setText("status");

		final Tree tree = new Tree(shell, SWT.BORDER);
		tree.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDoubleClick(MouseEvent e) {
			}
		});
		tree.setBounds(10, 121, 228, 404);

		TreeColumn trclmnName = new TreeColumn(tree, SWT.NONE);
		trclmnName.setWidth(200);

		TreeItem treeItem = new TreeItem(tree, SWT.NONE);
		treeItem.setText("Folder");
//
//		TreeItem t1i = new TreeItem(treeItem, SWT.NONE);
//		t1i.setText("Child");
//		treeItem.setExpanded(true);

		Button btnLogin = new Button(shell, SWT.NONE);
		btnLogin.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				if((txtFtpurl.equals(""))|(txtFtpusername.equals(""))|txtFtpport.equals("")) {
					lblStatus.setText("missing parameters");
				} else {
					FtpLogin.ftpUsername = txtFtpusername.getText();
					FtpLogin.ftpPassword = txtFtppassword.getText();
					FtpLogin.ftpUrl = txtFtpurl.getText();
					Runnable ftploginrunnable = new FtpLogin();
					Thread ftploginthread = new Thread(ftploginrunnable);
					ftploginthread.start();
				}
			}
		});
		btnLogin.setBounds(144, 85, 94, 30);
		btnLogin.setText("Login");

		Label lblUrl = new Label(shell, SWT.NONE);
		lblUrl.setAlignment(SWT.RIGHT);
		lblUrl.setBounds(10, 13, 59, 14);
		lblUrl.setText("ftp://");

		Label lblUsername = new Label(shell, SWT.NONE);
		lblUsername.setAlignment(SWT.RIGHT);
		lblUsername.setBounds(10, 38, 59, 14);
		lblUsername.setText("Username");

		Label lblPassword = new Label(shell, SWT.NONE);
		lblPassword.setAlignment(SWT.RIGHT);
		lblPassword.setBounds(10, 63, 59, 14);
		lblPassword.setText("Password");

		Label label = new Label(shell, SWT.SEPARATOR | SWT.HORIZONTAL);
		label.setBounds(0, 531, 500, 2);


		Label label_1 = new Label(shell, SWT.SEPARATOR | SWT.VERTICAL);
		label_1.setBounds(244, 531, 2, 19);

		Button btnList = new Button(shell, SWT.NONE);
		btnList.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				lblStatus.setText("Isaac");
				try {
					for (FTPFile f : FtpLogin.ftpClient.listFiles()) {
						String fn = f.getName();
						TreeItem ti = new TreeItem(tree, SWT.NONE);
						ti.setText(fn);
						if(f.getType() == 1) {
							TreeItem cnts = new TreeItem(ti, SWT.NONE);
							cnts.setText("Directory Contents");

							cnts.addListener(SWT.MouseDown,  new Listener() {

								@Override
								public void handleEvent(Event arg0) {
									System.out.println("Item clicked");

								}

							});

						}
					}
				} catch (IOException e1) {
					// TODO Auto-generated catch block
					e1.printStackTrace();
				}
			}
		});
		btnList.setBounds(247, 121, 94, 30);
		btnList.setText("List");

		ProgressBar progressBar = new ProgressBar(shell, SWT.NONE);
		progressBar.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseDown(MouseEvent e) {
			}
		});
		progressBar.setBounds(310, 200, 140, 14);
		
		Canvas canvas = new Canvas(shell, SWT.NONE);
		canvas.addMouseMoveListener(new MouseMoveListener() {
			public void mouseMove(MouseEvent arg0) {
				Point p = MouseInfo.getPointerInfo().getLocation();
				int px = (int)p.getX();
				int py = (int)p.getY();
				System.out.println(px + ":" + py);
			}
		});
		canvas.addDragDetectListener(new DragDetectListener() {
			public void dragDetected(DragDetectEvent arg0) {

			}
		});
		canvas.setBounds(272, 237, 178, 156);
		shell.setTabList(new Control[]{txtFtpurl, txtFtpport, txtFtpusername, txtFtppassword, btnLogin, btnList, tree, progressBar, canvas});

	}
}
