package org.isaacparker.posdos;

import java.awt.Dimension;
import java.awt.Toolkit;

import javax.sound.sampled.Line;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.events.VerifyEvent;
import org.eclipse.swt.events.VerifyListener;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.wb.swt.SWTResourceManager;
import org.eclipse.swt.widgets.Slider;
import org.eclipse.swt.widgets.ProgressBar;

public class Inputitems {

	String[][][][][] productInfo;
	static Shell shell;
	private Text txtItemNumber;
	private Text txtItemPrice;
	private Text txtItemTaxRate = null;
	private Text txtItemName;

	public static void main(String[] args) {

		//		class SystemPOSManager implements Runnable {
		//			public void run() {
		//				while(true) {
		//					try {
		//						Thread.sleep(1000);
		//						if(Inputitems.shell.isVisible()) {
		//							System.out.println("Shell is disposed...");
		//						}
		//						Thread.sleep(100);
		//					} catch (InterruptedException e) {
		//						// TODO Auto-generated catch block
		//						e.printStackTrace();
		//					}
		//				}
		//			}
		//		}
		//		Runnable runnable = new SystemPOSManager();
		//		Thread thread = new Thread(runnable);
		//		thread.start();


		try {
			Inputitems window = new Inputitems();
			window.open();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * Open the window.
	 */
	public void open() {
		Display display = Display.getDefault();
		createContents();
		shell.open();
		shell.layout();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
	}

	/**
	 * Create contents of the window.
	 */
	protected void createContents() {
		Toolkit toolkit =  Toolkit.getDefaultToolkit ();
		Dimension dim = toolkit.getScreenSize();
		//System.out.println("Width of Screen Size is "+dim.width+" pixels");
		//System.out.println("Height of Screen Size is "+dim.height+" pixels");
		System.out.println("----------------------");
		System.out.println("This applications requires");
		System.out.println("a screen resolution of at");
		System.out.println("least 1280x1024.");
		System.out.println("----------------------");
		if (dim.width < 1280 | dim.height < 1024) {
			System.out.println("----------------------");
			System.out.println("Screen size too small");
			System.out.println("Exiting...");
			System.out.println("----------------------");
			System.exit(-1);
		}

		shell = new Shell();
		shell.setSize(1004, 315);
		//shell.setSize(900, 300);
		shell.setMinimumSize(1280, 1024);
		shell.setFullScreen(true);
		shell.setText("SWT Application");

		int cw = shell.getSize().x - 20;
		//int ch = shell.getSize().y - 20;
		int ch = 80;
		Composite composite = new Composite(shell, SWT.BORDER | SWT.EMBEDDED);
		composite.setBounds(10, 10, 1660, 95);

		int txtY = 46;
		int txtH = 30;

		int txtSpace = 10;

		int txtItemNameW = 220;
		int txtItemNameX = txtSpace;
		txtItemName = new Text(composite, SWT.BORDER);
		txtItemName.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		txtItemName.setFont(SWTResourceManager.getFont("Lucida Grande", 20, SWT.NORMAL));
		txtItemName.setBounds(txtItemNameX, txtY, txtItemNameW, txtH);

		int txtItemNumberW = 230;
		int txtItemNumberX = txtSpace + txtItemNameW + txtSpace;
		txtItemNumber = new Text(composite, SWT.BORDER);
		txtItemNumber.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		txtItemNumber.setFont(SWTResourceManager.getFont("Lucida Grande", 20, SWT.NORMAL|SWT.FOCUSED));
		txtItemNumber.setBounds(txtItemNumberX, txtY, txtItemNumberW, txtH);

		int txtItemPriceW = 170;
		int txtItemPriceX = txtSpace + txtItemNameW + txtSpace + txtItemNumberW + txtSpace;
		txtItemPrice = new Text(composite, SWT.BORDER);
		txtItemPrice.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		txtItemPrice.setFont(SWTResourceManager.getFont("Lucida Grande", 20, SWT.NORMAL));
		txtItemPrice.setBounds(txtItemPriceX, txtY, txtItemPriceW, txtH);

		final Event event = new Event();
		int txtItemTaxRateW = 110;
		int txtItemTaxRateX = txtItemPriceX + txtItemPriceW + txtSpace;
		txtItemTaxRate = new Text(composite, SWT.BORDER | SWT.RIGHT);
		txtItemTaxRate.setBackground(SWTResourceManager.getColor(SWT.COLOR_WIDGET_BACKGROUND));
		txtItemTaxRate.addListener(SWT.KeyDown, new Listener() {
			@Override
			public void handleEvent(Event arg0) {
				switch (arg0.keyCode) {
				case SWT.BS:
				case SWT.DEL:
				case SWT.HOME:
				case SWT.END:
				case SWT.ARROW_LEFT:
				case SWT.ARROW_RIGHT:
					return;
				}
//				char c = arg0.character;
//				boolean isDot = true;
//				if(c == '.') {
//					isDot = false;
//				} else {
//					isDot = true;
//				}
				if(!Character.isDigit(arg0.character)) {
					arg0.doit = false;
				}
				
			}
		});
//		txtItemTaxRate.addVerifyListener(new VerifyListener() {
//
//			@Override
//			public void verifyText(VerifyEvent arg0) {
//				switch (event.keyCode) {
//				case SWT.BS:
//				case SWT.DEL:
//				case SWT.HOME:
//				case SWT.END:
//				case SWT.ARROW_LEFT:
//				case SWT.ARROW_RIGHT:
//					return;
//				}
//				
//				if(!Character.isDigit(event.character)) {
//					event.doit = false;
//				}
//
//			}
//		});
		txtItemTaxRate.setFont(SWTResourceManager.getFont("Lucida Grande", 20, SWT.NORMAL));
		txtItemTaxRate.setBounds(txtItemTaxRateX, txtY, txtItemTaxRateW, txtH);

		//int productNum = 0;
		
		Line getLine;
		Line.Info info;
		

		int btnEnterW = 114;
		int btnEnterX = txtItemTaxRateX + txtItemTaxRateW + txtSpace;
		Button btnEnter = new Button(composite, SWT.FLAT);
		btnEnter.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {

				Product product = new Product();
				product.itemName = txtItemName.getText();
				product.itemNumber = txtItemNumber.getText();
				try {
					product.price = Integer.parseInt(txtItemPrice.getText());
					product.taxRate = Integer.parseInt(txtItemTaxRate.getText());
				} catch (Exception e1) {
					System.out.println("Item price or item tax rate is not an integer");
				}
				
				
				//JODBServer server = JODB.
				//				String[][] names = {
				//						{"1","2"},
				//						{"3","4"}
				//				};	
				//				String one[][] = {
				//						{"1","1","1","1"},
				//						{"4","4","4","4"}
				//				};
				//String[][][][] one = {{"1","1","1","1"},{"2","2","2","2"},{"3","3","3","3"},{"4","4","4","4"}};
			}
		});
		btnEnter.setBounds(btnEnterX, txtY, btnEnterW, txtH);
		btnEnter.setText("Enter");

		Label lblItemName = new Label(composite, SWT.NONE);
		lblItemName.setFont(SWTResourceManager.getFont("Lucida Grande", 13, SWT.BOLD));
		lblItemName.setBounds(0, 0, 220, 30);
		lblItemName.setText("Item Name");

		Label lblItemNumber = new Label(composite, SWT.NONE);
		lblItemNumber.setFont(SWTResourceManager.getFont("Lucida Grande", 13, SWT.BOLD));
		lblItemNumber.setBounds(226, 0, 235, 30);
		lblItemNumber.setText("Item Number");

		Label lblItemPrice = new Label(composite, SWT.NONE);
		lblItemPrice.setFont(SWTResourceManager.getFont("Lucida Grande", 13, SWT.BOLD));
		lblItemPrice.setBounds(462, 0, 170, 30);
		lblItemPrice.setText("Item Price");

		Label lblItemTaxRate = new Label(composite, SWT.NONE);
		lblItemTaxRate.setFont(SWTResourceManager.getFont("Lucida Grande", 13, SWT.BOLD));
		lblItemTaxRate.setBounds(638, 0, 110, 30);
		lblItemTaxRate.setText("Item Tax Rate");
		composite.setTabList(new Control[]{txtItemName, txtItemNumber, txtItemPrice, txtItemTaxRate, btnEnter});
		
		Slider slider = new Slider(shell, SWT.NONE);
		slider.setPageIncrement(1);
		slider.setThumb(5);
		slider.setBounds(10, 111, 895, 15);
		
		ProgressBar progressBar = new ProgressBar(shell, SWT.NONE);
		progressBar.setBounds(10, 132, 895, 14);

	}
}
